/*
** Copyright (c) 1995-2001  Hughes Technologies Pty Ltd.  All rights
** reserved.  
**
** Terms under which this software may be used or copied are
** provided in the  specific license associated with this product.
**
** Hughes Technologies disclaims all warranties with regard to this 
** software, including all implied warranties of merchantability and 
** fitness, in no event shall Hughes Technologies be liable for any 
** special, indirect or consequential damages or any damages whatsoever 
** resulting from loss of use, data or profits, whether in an action of 
** contract, negligence or other tortious action, arising out of or in 
** connection with the use or performance of this software.
**
**
** $Id: datetime.c,v 1.1 2004/07/22 00:24:51 bambi Exp $
**
*/

/*
** Module	: main : datetime
** Purpose	: 
** Exports	: 
** Depends Upon	: 
*/



/**************************************************************************
** STANDARD INCLUDES
**************************************************************************/

#include <common/config.h>

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#ifdef HAVE_UNISTD_H
#  include <unistd.h>
#endif
#ifdef HAVE_STRING_H
#  include <string.h>
#endif
#ifdef HAVE_STRINGS_H
#  include <strings.h>
#endif

#include <common/portability.h>

/**************************************************************************
** MODULE SPECIFIC INCLUDES
**************************************************************************/

#define __USE_XOPEN	/* For linux */
#include <time.h>
#undef __USE_XOPEN

#include <common/msql_defs.h>
#include <common/debug/debug.h>
#include <msqld/index/index.h>
#include <msqld/includes/msqld.h>
#include <common/types/types.h>


/**************************************************************************
** GLOBAL VARIABLES
**************************************************************************/


/**************************************************************************
** PRIVATE ROUTINES
**************************************************************************/


/**************************************************************************
** PUBLIC ROUTINES
**************************************************************************/


char *msqlUnixTimeToDatetime(clock)
	time_t	clock;
{
	static char	result[25];
	snprintf(result,24,"%s %s", 
		msqlUnixTimeToDate(clock),
		msqlUnixTimeToTime(clock));
	return(result);
}


time_t msqlDatetimeToUnixTime(datetime)
	char	*datetime;
{
	char	*buf,
		*time;
	int	timeVal,
		dateVal;
	time_t	clock;

	if (!datetime)
		return(-1);
	buf = strdup(datetime);
	time = index(buf,' ');
	if (!time)
	{
		free(buf);
		return(-1);
	}

	*time = 0;
	timeVal =  msqlTimeToUnixTime(time + 1);
	dateVal =  msqlDateToUnixTime(buf);
	if (timeVal < 0 || dateVal < 0)
	{
		free(buf);
		return(-1);
	}
	clock = (u_int)dateVal + (u_int)timeVal;
	return(clock);
}

